// fix_ntice_pathes.cpp : Defines the entry point for the console application.
//

#include <windows.h>
#include <stdio.h>
#include <string.h>

typedef unsigned char UCHAR;
typedef unsigned short USHORT;
typedef unsigned long ULONG;

#define NTICE_REG "SYSTEM\\CurrentControlSet\\Services\\NTice\\DOSDeviceList"

typedef LONG NTSTATUS ;

#define NT_SUCCESS(Status) ((NTSTATUS)(Status) >= 0)

#define ExAllocatePool(fignia, sz)  GlobalAlloc(GMEM_DISCARDABLE, sz)
#define ExFreePool(ptr) GlobalFree(ptr)

OSVERSIONINFO OsVerInfo;
ULONG MajorVersion;
ULONG MinorVersion;

#define WinVer_Is351  (MajorVersion==0x03 && MinorVersion==51)
#define WinVer_IsNT   (MajorVersion==0x04)
#define WinVer_Is2k   (MajorVersion==0x05 && MinorVersion==0x00)
#define WinVer_IsXP   (MajorVersion==0x05 && MinorVersion==0x01)
#define WinVer_IsdNET (MajorVersion==0x05 && MinorVersion==0x02)

#define MAX_UNI_PATH (1024*sizeof(WCHAR))

//
// Pointer to Unsigned Basics
//

typedef struct _UNICODE_STRING {
    USHORT Length;
    USHORT MaximumLength;
    PWSTR  Buffer;
} UNICODE_STRING;
typedef UNICODE_STRING *PUNICODE_STRING;

typedef struct _OBJECT_ATTRIBUTES {
    ULONG Length;
    HANDLE RootDirectory;
    PUNICODE_STRING ObjectName;
    ULONG Attributes;
    PVOID SecurityDescriptor;        // Points to type SECURITY_DESCRIPTOR
    PVOID SecurityQualityOfService;  // Points to type SECURITY_QUALITY_OF_SERVICE
} OBJECT_ATTRIBUTES;
typedef OBJECT_ATTRIBUTES *POBJECT_ATTRIBUTES;

#define InitializeObjectAttributes( p, n, a, r, s ) { \
    (p)->Length = sizeof( OBJECT_ATTRIBUTES );          \
    (p)->RootDirectory = r;                             \
    (p)->Attributes = a;                                \
    (p)->ObjectName = n;                                \
    (p)->SecurityDescriptor = s;                        \
    (p)->SecurityQualityOfService = NULL;               \
    }
#define OBJ_CASE_INSENSITIVE    0x00000040L

#define DIRECTORY_QUERY                 (0x0001)
#define DIRECTORY_TRAVERSE              (0x0002)
#define DIRECTORY_CREATE_OBJECT         (0x0004)
#define DIRECTORY_CREATE_SUBDIRECTORY   (0x0008)

#define SYMBOLIC_LINK_QUERY (0x0001)

__inline
NTSTATUS
RtlInitUnicodeString(PUNICODE_STRING ustr, PWCHAR buf) {
    ustr->Buffer = buf;
    ustr->Length = wcslen(buf)*sizeof(WCHAR);
    ustr->MaximumLength = ustr->Length+sizeof(WCHAR);
    return 0;
}


ULONG (__stdcall *NtCreateSymbolicLinkObject)(
                PHANDLE SymbolicLinkHandle,
                ACCESS_MASK DesiredAccess,
                POBJECT_ATTRIBUTES ObjectAttributes,
                PUNICODE_STRING DeviceName);

ULONG (__stdcall *NtOpenSymbolicLinkObject)(
                PHANDLE LinkHandle,
                ACCESS_MASK DesiredAccess,
                POBJECT_ATTRIBUTES ObjectAttributes);

ULONG (__stdcall *NtQuerySymbolicLinkObject)(
                HANDLE LinkHandle,
                PUNICODE_STRING LinkTarget,
                PULONG ReturnedLength);

ULONG (__stdcall *NtClose)(HANDLE Handle);

ULONG (__stdcall *NtOpenDirectoryObject)(
    OUT PHANDLE hDirectory,
	IN ACCESS_MASK AccessMask,
	IN POBJECT_ATTRIBUTES ObjectAttributes);


//--------------------------------------------------------------------
//
// LocateNDLLCalls
//
// Loads function entry points in NTDLL
//
//--------------------------------------------------------------------
BOOLEAN LocateNTDLLCalls()
{

    if( !(NtCreateSymbolicLinkObject = (void *) GetProcAddress( GetModuleHandle("ntdll.dll"),
            "NtCreateSymbolicLinkObject" )) ) {
        return FALSE;
    }
    if( !(NtOpenSymbolicLinkObject = (void *) GetProcAddress( GetModuleHandle("ntdll.dll"),
            "NtOpenSymbolicLinkObject" )) ) {
        return FALSE;
    }
    if( !(NtQuerySymbolicLinkObject = (void *) GetProcAddress( GetModuleHandle("ntdll.dll"),
            "NtQuerySymbolicLinkObject" )) ) {
        return FALSE;
    }
    if( !(NtClose = (void *) GetProcAddress( GetModuleHandle("ntdll.dll"),
            "NtClose" )) ) {
        return FALSE;
    }
    if( !(NtOpenDirectoryObject = (void *) GetProcAddress( GetModuleHandle("ntdll.dll"),
            "NtOpenDirectoryObject" )) ) {
        return FALSE;
    }

    return TRUE;
}

BOOL GainAllPrivileges(void)
{
    HANDLE              hToken;
    PTOKEN_PRIVILEGES   tp;
    DWORD               ReturnLength;
    DWORD               i;
    //
    // obtain the token, first check the thread and then the process
    //
    if (!OpenThreadToken(GetCurrentThread(), TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY, TRUE, &hToken)){
        if (GetLastError() == ERROR_NO_TOKEN){
            if (!OpenProcessToken(GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY, &hToken))
                return FALSE;
        } else return FALSE;
    }

    GetTokenInformation(hToken,TokenPrivileges, NULL,0L, &ReturnLength);
    tp = malloc(ReturnLength);
    GetTokenInformation(hToken,TokenPrivileges, tp, ReturnLength, &ReturnLength);

    for (i=0; i<tp->PrivilegeCount;i++) {
        tp->Privileges[i].Attributes = SE_PRIVILEGE_ENABLED;
    }

    if (!AdjustTokenPrivileges(hToken, FALSE, tp, 0, ( PTOKEN_PRIVILEGES)NULL, 0))
         return FALSE;

    if (!CloseHandle(hToken))
         return FALSE;

    free(tp);
    return TRUE;
}

BOOLEAN ParseSymLink(IN PUNICODE_STRING SrcUniName, OUT PUNICODE_STRING DstPathName);

int main(int argc, char* argv[])
{
    ULONG RC;
//    ULONG ReturnedLength;
    CHAR szTemp[1024];
    CHAR szVal[1024];
    WCHAR DrvPath[] = L"\\??\\?:";

    UNICODE_STRING SrcUniName;
    UNICODE_STRING DstUniName;
    HKEY hKey;

    CHAR drv;
    ULONG drv_bmap;

    printf("NtIce path fix utility, (c) Alexander A. Telyatnikov, 2003\n");

    if (!GainAllPrivileges()) return 1;
    LocateNTDLLCalls();

    GetVersionEx(&OsVerInfo);
    MajorVersion = OsVerInfo.dwMajorVersion;
    MinorVersion = OsVerInfo.dwMinorVersion;

    drv_bmap = GetLogicalDrives();
    if(ERROR_SUCCESS != RegOpenKeyEx(HKEY_LOCAL_MACHINE, NTICE_REG, 0, KEY_ALL_ACCESS, &hKey))
        exit(2);
    for(drv = 0 ; drv < 26 ; drv++) {
     
        sprintf(&szVal[0], "%c:", drv+'A');
        RegDeleteValue(hKey, &szVal[0]);
        if(! ((drv_bmap >> drv) & 1) )
            continue;
        szVal[2] = '\\';
        szVal[3] = 0;
        RC = GetDriveType(&szVal[0]);
        szVal[2] = 0;
        if(RC == DRIVE_REMOTE || RC == DRIVE_RAMDISK)
            continue;
        DrvPath[4] = drv+'A';
        RtlInitUnicodeString(&SrcUniName, &DrvPath[0]);

        RC = ParseSymLink(&SrcUniName, &DstUniName);
        if(!NT_SUCCESS(RC))
            continue;
        sprintf(&szTemp[0], "%ws", DstUniName.Buffer);
        printf("%c: %s\n",drv+'A',&szTemp[0]);
        RegSetValueEx(hKey, &szVal[0], 0, REG_SZ, &szTemp[0], strlen(&szTemp[0])+1);
        ExFreePool(DstUniName.Buffer);
    }

    RtlInitUnicodeString(&SrcUniName, L"\\SystemRoot");
    RC = ParseSymLink(&SrcUniName, &DstUniName);
    sprintf(&szTemp[0], "%ws", DstUniName.Buffer);
    printf("SystemRoot: %s\n",&szTemp[0]);
    RegSetValueEx(hKey, "SystemRoot", 0, REG_SZ, &szTemp[0], strlen(&szTemp[0])+1);
    ExFreePool(DstUniName.Buffer);
    RegCloseKey(hKey);

    return 0;
}

BOOLEAN ParseSymLink(IN PUNICODE_STRING _SrcUniName, OUT PUNICODE_STRING DstPathName)
{
  BOOLEAN  IsSuccess = FALSE;
  NTSTATUS NtStatus  = 0;//STATUS_INSUFFICIENT_RESOURCES;
  __try
  {
    HANDLE         SymLinkHandle      = NULL;
    HANDLE         ObDirHandle = NULL;

    PWCHAR         SymLinkNameBuffer = NULL; 
    PWCHAR         NewNameBuffer = NULL; 
    UNICODE_STRING SrcUniName = *_SrcUniName;
    UNICODE_STRING DstUniName;
    UNICODE_STRING PathName;

    ULONG i;
    ULONG prev_i=0;
    ULONG lim;

    OBJECT_ATTRIBUTES   ObAttributes;

    SymLinkNameBuffer = (PWCHAR)ExAllocatePool(NonPagedPool, MAX_UNI_PATH + 2);
    NewNameBuffer     = (PWCHAR)ExAllocatePool(NonPagedPool, MAX_UNI_PATH + 2);
    PathName.Buffer   = NewNameBuffer;

    memcpy(SymLinkNameBuffer, SrcUniName.Buffer, SrcUniName.MaximumLength);
    memcpy(NewNameBuffer, SrcUniName.Buffer, SrcUniName.MaximumLength);

    if(SymLinkNameBuffer && NewNameBuffer) {
      lim = SrcUniName.Length / sizeof(WCHAR);
    }

    while (SymLinkNameBuffer && NewNameBuffer)
    {
      for(i=prev_i+1; i<lim; i++) {
        if(NewNameBuffer[i] == '\\') {
          break;
        }
      }
      // Open the Directory:
      memcpy(SymLinkNameBuffer, NewNameBuffer, (prev_i ? prev_i : 1)*sizeof(WCHAR));
      SymLinkNameBuffer[prev_i ? prev_i : 1] = 0;
      RtlInitUnicodeString(&SrcUniName, SymLinkNameBuffer);

      InitializeObjectAttributes(&ObAttributes,
                                 &SrcUniName,
                                 OBJ_CASE_INSENSITIVE,
                                 (HANDLE)NULL,
                                 (PSECURITY_DESCRIPTOR)NULL);

      NtStatus = NtOpenDirectoryObject(&ObDirHandle,
                                       DIRECTORY_QUERY,
                                       &ObAttributes);

      if (NT_SUCCESS(NtStatus))
      {
        memcpy(SymLinkNameBuffer, NewNameBuffer+prev_i+1, (i-prev_i-1)*sizeof(WCHAR));
        SymLinkNameBuffer[i-prev_i-1] = 0;
        RtlInitUnicodeString(&SrcUniName, SymLinkNameBuffer);

        InitializeObjectAttributes(&ObAttributes,
                                   &SrcUniName,
                                   OBJ_CASE_INSENSITIVE,
                                   (HANDLE)ObDirHandle,
                                   (PSECURITY_DESCRIPTOR)NULL);

        NtStatus = NtOpenSymbolicLinkObject(&SymLinkHandle,
                                            SYMBOLIC_LINK_QUERY,
                                            &ObAttributes);
        if (NT_SUCCESS(NtStatus))
        {
          memset(SymLinkNameBuffer, 0, MAX_UNI_PATH);
          DstUniName.Length        = 0;
          DstUniName.MaximumLength = MAX_UNI_PATH;
          DstUniName.Buffer        = SymLinkNameBuffer;

          NtStatus = NtQuerySymbolicLinkObject(SymLinkHandle,
                                               &DstUniName,
                                               NULL);
            // Close handle in current process context:
            NtClose((HANDLE) SymLinkHandle);
        } else {
          // next pattern
          prev_i = i;
          continue;
        }

        if (NT_SUCCESS(NtStatus))
        {
          if(DstUniName.Length &&
             SymLinkNameBuffer[(DstUniName.Length-1)/sizeof(WCHAR)] == '\\') {
            DstUniName.Length--;
            SymLinkNameBuffer[(DstUniName.Length)/sizeof(WCHAR)] = 0;
          }
          memcpy(SymLinkNameBuffer+(DstUniName.Length/sizeof(WCHAR)),
                 NewNameBuffer+i, (lim-i)*sizeof(WCHAR));
          DstUniName.Length += (USHORT)((lim-i)*sizeof(WCHAR));

          memcpy(NewNameBuffer, SymLinkNameBuffer, DstUniName.Length);
          NewNameBuffer[DstUniName.Length/sizeof(WCHAR)] = 0;
          PathName.Length = DstUniName.Length;

          prev_i = 0;
          i = 0;
          lim = PathName.Length/sizeof(WCHAR);
          
        } else {
          // Quit
          NewNameBuffer = NULL;
        }

          // Close handle in current process context:
          NtClose((HANDLE) ObDirHandle);
      } else {
        break;
      }
      if(i>=lim) {
        break;
      }

    }
    RtlInitUnicodeString(DstPathName, NewNameBuffer);
  }
  __except(EXCEPTION_EXECUTE_HANDLER)
  {

    IsSuccess = FALSE;
  }

  return IsSuccess;
}
